Index: configure
===================================================================
--- configure	(revision 685)
+++ configure	(working copy)
@@ -255,7 +255,13 @@
   x86_64)
     ARCH="X86_64"
     AS="yasm"
-    ASFLAGS="-f elf -m amd64"
+	if [ "$SYS" = MACOSX ];then
+		ASFLAGS="-f macho64 -m amd64 -D__PIC__ -DPREFIX"
+		CFLAGS="$CFLAGS -arch x86_64"
+		LDFLAGS="$LDFLAGS -arch x86_64"
+	else
+    	ASFLAGS="-f elf -m amd64"
+	fi
     ;;
   powerpc|powerpc64)
     ARCH="PPC"
Index: common/amd64/deblock-a.asm
===================================================================
--- common/amd64/deblock-a.asm	(revision 685)
+++ common/amd64/deblock-a.asm	(working copy)
@@ -24,7 +24,7 @@
 
 %include "amd64inc.asm"
 
-SECTION .rodata align=16
+SECTION_RODATA
 pb_01: times 16 db 0x01
 pb_03: times 16 db 0x03
 pb_a1: times 16 db 0xa1
Index: common/amd64/amd64inc.asm
===================================================================
--- common/amd64/amd64inc.asm	(revision 685)
+++ common/amd64/amd64inc.asm	(working copy)
@@ -41,6 +41,18 @@
     %1:
 %endmacro
 
+; Name of the .rodata section. On OS X we cannot use .rodata because NASM
+; is unable to compute address offsets outside of .text so we use the .text
+; section instead until NASM is fixed.
+%macro SECTION_RODATA 0
+    %ifidn __OUTPUT_FORMAT__,macho
+        SECTION .text align=16
+        fakegot:
+    %else
+        SECTION_RODATA
+    %endif
+%endmacro
+
 %macro pad 1
     %undef %1
     %ifdef PREFIX
Index: common/amd64/quant-a.asm
===================================================================
--- common/amd64/quant-a.asm	(revision 685)
+++ common/amd64/quant-a.asm	(working copy)
@@ -24,7 +24,7 @@
 
 %include "amd64inc.asm"
 
-SECTION .rodata
+SECTION_RODATA
 pd_1:  times 2 dd 1
 
 SECTION .text
Index: common/amd64/dct-a.asm
===================================================================
--- common/amd64/dct-a.asm	(revision 685)
+++ common/amd64/dct-a.asm	(working copy)
@@ -148,7 +148,7 @@
 ; Constants
 ;=============================================================================
 
-SECTION .rodata align=16
+SECTION_RODATA
 pw_1:  times 8 dw 1
 pw_32: times 8 dw 32
 
Index: common/amd64/predict-a.asm
===================================================================
--- common/amd64/predict-a.asm	(revision 685)
+++ common/amd64/predict-a.asm	(working copy)
@@ -58,7 +58,7 @@
 %endmacro
 
 
-SECTION .rodata align=16
+SECTION_RODATA
 
 ALIGN 16
 pw_2: times 4 dw 2
Index: common/amd64/pixel-sse2.asm
===================================================================
--- common/amd64/pixel-sse2.asm	(revision 685)
+++ common/amd64/pixel-sse2.asm	(working copy)
@@ -29,7 +29,7 @@
 
 %include "amd64inc.asm"
 
-SECTION .rodata align=16
+SECTION_RODATA
 
 pw_1:    times 8 dw 1
 ssim_c1: times 4 dd 416    ; .01*.01*255*255*64
Index: common/amd64/mc-a.asm
===================================================================
--- common/amd64/mc-a.asm	(revision 685)
+++ common/amd64/mc-a.asm	(working copy)
@@ -42,7 +42,7 @@
 ; Constants
 ;=============================================================================
 
-SECTION .rodata
+SECTION_RODATA
 
 ALIGN 16
 pw_4:  times 4 dw  4
Index: common/amd64/mc-a2.asm
===================================================================
--- common/amd64/mc-a2.asm	(revision 685)
+++ common/amd64/mc-a2.asm	(working copy)
@@ -30,7 +30,7 @@
 ; Read only data
 ;=============================================================================
 
-SECTION .rodata align=16
+SECTION_RODATA
 
 ALIGN 16
 pw_1:  times 4 dw 1